Attribute VB_Name = "Module1"
Type SECURITY_ATTRIBUTES
nLength As Long
lpSecurityDescriptor As Long
bInheritHandle As Long
End Type

Type OVERLAPPED
 Internal As Long
 InternalHigh As Long
 offset As Long
 OffsetHigh As Long
 hEvent As Long
End Type

Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, lpSecurityAttributes As SECURITY_ATTRIBUTES, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Declare Function DeviceIoControl Lib "kernel32" (ByVal hDevice As Long, ByVal dwIoControlCode As Long, lpInBuffer As Any, ByVal nInBufferSize As Long, lpOutBuffer As Any, ByVal nOutBufferSize As Long, lpBytesReturned As Long, lpOverlapped As OVERLAPPED) As Long
Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long


Public Security As SECURITY_ATTRIBUTES
Public gOverlapped As OVERLAPPED
Public hgDrvrHnd As Long
Public Const GENERIC_READ = &H80000000
Public Const GENERIC_WRITE = &H40000000
Public Const FILE_SHARE_WRITE = &H2
Public Const FILE_SHARE_READ = &H1
Public Const OPEN_EXISTING = &H3

Dim sFileName As String
Dim htemp As Long
Dim lIn As Long, lInSize As Long, lOut As Long, lOutSize As Long, lSize As Long
Dim lTemp As Long

Public Sub USB_IO()
  sFileName = "\\.\usbuart_0"
  hgDrvrHnd = CreateFile(sFileName, GENERIC_WRITE Or GENERIC_READ, FILE_SHARE_WRITE Or FILE_SHARE_READ, Security, OPEN_EXISTING, 0, 0)
  lTemp = DeviceIoControl(hgDrvrHnd, 4&, lIn, lInSize, lOut, lOutSize, lSize, gOverlapped)
  htemp = CloseHandle(hgDrvrHnd)
End Sub
Public Function RdPort0() As Integer
  lIn = 0 * 256 + 20
  lInSize = 2
  lOutSize = 2
  USB_IO
  RdPort0 = (lOut / 256) And 255
End Function
Public Function RdPort1() As Integer
  lIn = 1 * 256 + 20
  lInSize = 2
  lOutSize = 2
  USB_IO
  RdPort1 = (lOut / 256) And 255
End Function
Public Sub WrPort0(Wert)
  lIn = 65536 * Wert + 0 * 256 + 21
  lInSize = 3
  lOutSize = 1
  USB_IO
End Sub
Public Sub WrPort1(Wert)
  lIn = 65536 * Wert + 1 * 256 + 21
  lInSize = 3
  lOutSize = 1
  USB_IO
End Sub

Public Sub WrIsink(Pin, Wert)
  lIn = 65536 * Wert + Pin * 256 + 23
  lInSize = 3
  lOutSize = 1
  USB_IO
End Sub
Public Sub WrPullups(Port, Wert)
  lIn = 65536 * (255 - Wert) + (Port + 16) * 256 + 23
  lInSize = 3
  lOutSize = 1
  USB_IO
End Sub
